<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::lz77_buffer_kernel_1&lt; sliding_buffer &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1lz77__buffer__kernel__1.html">lz77_buffer_kernel_1</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1lz77__buffer__kernel__1-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::lz77_buffer_kernel_1&lt; sliding_buffer &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a29af12178c8bea7fefc5bcb763f12ef2"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1lz77__buffer__kernel__1.html#a29af12178c8bea7fefc5bcb763f12ef2">lz77_buffer_kernel_1</a> (unsigned long total_limit_, unsigned long lookahead_limit_)</td></tr>
<tr class="separator:a29af12178c8bea7fefc5bcb763f12ef2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a44b2bdb1b3c7e7f5766ca586a469beaa"><td class="memItemLeft" align="right" valign="top"><a id="a44b2bdb1b3c7e7f5766ca586a469beaa"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:a44b2bdb1b3c7e7f5766ca586a469beaa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a608bc527e042e18935347ee422ec172b"><td class="memItemLeft" align="right" valign="top"><a id="a608bc527e042e18935347ee422ec172b"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>add</b> (unsigned char symbol)</td></tr>
<tr class="separator:a608bc527e042e18935347ee422ec172b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8493ec7f99ec6d92e82514d7f0a260db"><td class="memItemLeft" align="right" valign="top"><a id="a8493ec7f99ec6d92e82514d7f0a260db"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>find_match</b> (unsigned long &amp;index, unsigned long &amp;length, unsigned long min_match_length)</td></tr>
<tr class="separator:a8493ec7f99ec6d92e82514d7f0a260db"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4cc1a36923266e4ed48706c2f8a9412b"><td class="memItemLeft" align="right" valign="top"><a id="a4cc1a36923266e4ed48706c2f8a9412b"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>get_history_buffer_limit</b> () const</td></tr>
<tr class="separator:a4cc1a36923266e4ed48706c2f8a9412b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab68e75d9df08ef77f799f978b658b004"><td class="memItemLeft" align="right" valign="top"><a id="ab68e75d9df08ef77f799f978b658b004"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>get_lookahead_buffer_limit</b> () const</td></tr>
<tr class="separator:ab68e75d9df08ef77f799f978b658b004"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2834af155a0905d3c18511b137e8124c"><td class="memItemLeft" align="right" valign="top"><a id="a2834af155a0905d3c18511b137e8124c"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>get_history_buffer_size</b> () const</td></tr>
<tr class="separator:a2834af155a0905d3c18511b137e8124c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aceeb22a61817c56dcc79d354aad23dc5"><td class="memItemLeft" align="right" valign="top"><a id="aceeb22a61817c56dcc79d354aad23dc5"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>get_lookahead_buffer_size</b> () const</td></tr>
<tr class="separator:aceeb22a61817c56dcc79d354aad23dc5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6011adc814b9f94df3523deb90aae123"><td class="memItemLeft" align="right" valign="top"><a id="a6011adc814b9f94df3523deb90aae123"></a>
unsigned char&#160;</td><td class="memItemRight" valign="bottom"><b>lookahead_buffer</b> (unsigned long index) const</td></tr>
<tr class="separator:a6011adc814b9f94df3523deb90aae123"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a21fbb15a8c1ece01b43b319890f15855"><td class="memItemLeft" align="right" valign="top"><a id="a21fbb15a8c1ece01b43b319890f15855"></a>
unsigned char&#160;</td><td class="memItemRight" valign="bottom"><b>history_buffer</b> (unsigned long index) const</td></tr>
<tr class="separator:a21fbb15a8c1ece01b43b319890f15855"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5bd75944873c0e23f3cde7e0a9e17428"><td class="memItemLeft" align="right" valign="top"><a id="a5bd75944873c0e23f3cde7e0a9e17428"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>shift_buffers</b> (unsigned long N)</td></tr>
<tr class="separator:a5bd75944873c0e23f3cde7e0a9e17428"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a85a24ba19929e193b5401b94db98bc4b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1lz77__buffer__kernel__1.html#a85a24ba19929e193b5401b94db98bc4b">shift_buffer</a> (unsigned long N)</td></tr>
<tr class="separator:a85a24ba19929e193b5401b94db98bc4b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5bd7235faa1ec2a72e92b16472e53c61"><td class="memItemLeft" align="right" valign="top"><a id="a5bd7235faa1ec2a72e92b16472e53c61"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>lz77_buffer_kernel_1</b> (<a class="el" href="classdlib_1_1lz77__buffer__kernel__1.html">lz77_buffer_kernel_1</a>&lt; <a class="el" href="classdlib_1_1sliding__buffer.html">sliding_buffer</a> &gt; &amp;)</td></tr>
<tr class="separator:a5bd7235faa1ec2a72e92b16472e53c61"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a814b22c35752af65f11b52c8a130cbbe"><td class="memItemLeft" align="right" valign="top"><a id="a814b22c35752af65f11b52c8a130cbbe"></a>
<a class="el" href="classdlib_1_1lz77__buffer__kernel__1.html">lz77_buffer_kernel_1</a>&lt; <a class="el" href="classdlib_1_1sliding__buffer.html">sliding_buffer</a> &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1lz77__buffer__kernel__1.html">lz77_buffer_kernel_1</a>&lt; <a class="el" href="classdlib_1_1sliding__buffer.html">sliding_buffer</a> &gt; &amp;)</td></tr>
<tr class="separator:a814b22c35752af65f11b52c8a130cbbe"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a4258ee6b8993256148350c28caab6e93"><td class="memItemLeft" align="right" valign="top"><a id="a4258ee6b8993256148350c28caab6e93"></a>
<a class="el" href="classdlib_1_1sliding__buffer.html">sliding_buffer</a>&#160;</td><td class="memItemRight" valign="bottom"><b>buffer</b></td></tr>
<tr class="separator:a4258ee6b8993256148350c28caab6e93"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0bcbf7718e5ad63fe2663aac68bf7247"><td class="memItemLeft" align="right" valign="top"><a id="a0bcbf7718e5ad63fe2663aac68bf7247"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>lookahead_limit</b></td></tr>
<tr class="separator:a0bcbf7718e5ad63fe2663aac68bf7247"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a60eea34863ad64f58a5bcc5b5b2de942"><td class="memItemLeft" align="right" valign="top"><a id="a60eea34863ad64f58a5bcc5b5b2de942"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>history_limit</b></td></tr>
<tr class="separator:a60eea34863ad64f58a5bcc5b5b2de942"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4868e1236d9b69f24175ca272e47c847"><td class="memItemLeft" align="right" valign="top"><a id="a4868e1236d9b69f24175ca272e47c847"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>lookahead_size</b></td></tr>
<tr class="separator:a4868e1236d9b69f24175ca272e47c847"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aef482c3863b34afeeb632e0b1d1d864a"><td class="memItemLeft" align="right" valign="top"><a id="aef482c3863b34afeeb632e0b1d1d864a"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>history_size</b></td></tr>
<tr class="separator:aef482c3863b34afeeb632e0b1d1d864a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a29af12178c8bea7fefc5bcb763f12ef2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a29af12178c8bea7fefc5bcb763f12ef2">&#9670;&nbsp;</a></span>lz77_buffer_kernel_1()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename sliding_buffer &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classdlib_1_1lz77__buffer__kernel__1.html">dlib::lz77_buffer_kernel_1</a>&lt; <a class="el" href="classdlib_1_1sliding__buffer.html">sliding_buffer</a> &gt;::<a class="el" href="classdlib_1_1lz77__buffer__kernel__1.html">lz77_buffer_kernel_1</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>total_limit_</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>lookahead_limit_</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">REQUIREMENTS ON sliding_buffer
    sliding_buffer must be an implementation of sliding_buffer/sliding_buffer_kernel_abstract.h

INITIAL VALUE
    history_limit == defined by constructor arguments
    lookahead_limit == defined by constructor arguments
    history_size == 0
    lookahead_size == 0
    buffer.size() == history_limit + lookahead_limit


CONVENTION           
    history_limit == get_history_buffer_limit()
    lookahead_limit == get_lookahead_buffer_limit()
    history_size == get_history_buffer_size()
    lookahead_limit == get_lookahead_buffer_size()

    buffer.size() == history_limit + lookahead_limit

    lookahead_buffer(i) == buffer[lookahead_limit-1-i]
    history_buffer(i) == buffer[lookahead_limit+i]
</pre><p> ! </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a85a24ba19929e193b5401b94db98bc4b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a85a24ba19929e193b5401b94db98bc4b">&#9670;&nbsp;</a></span>shift_buffer()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename sliding_buffer&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1lz77__buffer__kernel__1.html">dlib::lz77_buffer_kernel_1</a>&lt; <a class="el" href="classdlib_1_1sliding__buffer.html">sliding_buffer</a> &gt;::shift_buffer </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>N</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - N &lt;= lookahead_size
ensuers
    - #lookahead_size == lookahead_size - N
    - if (history_size+N &lt; history_limit) then
        - #history_size == history_size+N
    - else
        - #history_size == history_limit
    - for all i where 0 &lt;= i &lt; N:
      #history_buffer(N-1-i) == lookahead_buffer(i)
    - for all i where 0 &lt;= i &lt; #history_size-N:
      #history_buffer(N+i) == history_buffer(i)
    - for all i where 0 &lt;= i &lt; #lookahead_size
      #lookahead_buffer(i) == lookahead_buffer(N+i)                
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="lz77__buffer__kernel__1_8h_source.html">lz77_buffer_kernel_1.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
